var knownPosition = false;

function geolocation_init() {
	// onSuccess Callback
	// This method accepts a Position object, which contains the
	// current GPS coordinates
	//
	var onSuccess = function(position) {
		knownPosition = {
			latitude: position.coords.latitude,
			longitude: position.coords.longitude,
			timestamp: position.timestamp
		};
	};

	// onError Callback receives a PositionError object
	// This may fire if GeoLocation is turned off on the device.
	function onError(error) {
		// if there's an error, try again in an hour
		setTimeout(geolocation_init, 3600000);
		//alert('code: '    + error.code    + '\n' + 'message: ' + error.message + '\n');
	}

	var geolocationOptions = {
		maximumAge: 3600000,
		timeout: 10000,
		enableHighAccuracy: false
	};

	navigator.geolocation.getCurrentPosition(onSuccess, onError, geolocationOptions);
}
