var inAppBrowserRef = false;
var inAppBrowserHistory = [];

var currentlyLoadingUrl;

function openInAppBrowser(urlToOpen, options) {

	if (!appIsOnline) {
		$.mobile.changePage("#offline");
		return;
	}

	if (!options) {
		options = {
			showLoading: true,
			forceExternal: false
		};
	}

	if (options.showLoading) {
		showLoading();
	}

	if (options.forceExternal) {
		window.open(urlToOpen, '_system');
		return;
	}

	currentlyLoadingUrl = urlToOpen;

	if (urlToOpen.indexOf(CONFIG_DOMAIN) !== -1) {
		// we are opening an app page
		var appendCharacter = "?";
		if (urlToOpen.indexOf("?") !== -1) {
			appendCharacter = "&";
		}

		var thisDevice = {
			cordova: device.cordova,
			platform: device.platform,
			uuid: device.uuid,
			version: device.version,
			model: device.model
		};

		var stringifiedDevice = encodeURIComponent(JSON.stringify(thisDevice));

		urlToOpen += appendCharacter + "device=" + stringifiedDevice;
	}

	inAppBrowserRef = window.open(urlToOpen, '_blank', 'location=no,toolbar=no,hardwareback=yes,hidden=yes');

	inAppBrowserRef.addEventListener('loadstop', IAB_loadstop);
	inAppBrowserRef.addEventListener('loadstart', IAB_loadstart);
	inAppBrowserRef.addEventListener('loaderror', IAB_loaderror);

}

function IAB_loadstart(event) {

	if (!appIsOnline) {
		try {
			inAppBrowserRef.close();
		} catch (e) {}
		setTimeout(function() {
			$.mobile.changePage("#offline");
		}, 300);
		return;
	}

	// We might be loading: a page in the app, a page external to the website, or a page on app.bristlr.com

	if (event.url.indexOf("https://local.app/") !== -1) {

		// Load a local App page
		var appPage = event.url.replace("https://local.app/", "");

		setTimeout(function() {
			inAppBrowserRef.close();
		}, 100);

		$.mobile.changePage("#" + appPage, {
			transition: "none"
		});

	} else if ((event.url.indexOf("facebook.com") === -1) && (event.url.indexOf(CONFIG_DOMAIN) === -1)) {

		window.open(event.url, '_system');

		// Discard the last page we were on 
		if (inAppBrowserHistory.length > 0) {
			// Load the previous page
			openInAppBrowser(inAppBrowserHistory[inAppBrowserHistory.length - 1]);
			inAppBrowserHistory.pop();
		} else {
			inAppBrowserRef.close();
		}


	} else if ((event.url.indexOf("/auth/facebook") !== -1) && (event.url.indexOf("/auth/facebook/") === -1)) {
		// attempting to log in with FB in the IAB
		inAppBrowserRef.close();
		facebookSignUp();
	} else if (event.url.indexOf("/logout") !== -1) {
		forgetUser();
		inAppBrowserRef.close();
		$.mobile.changePage("#page1");
	}
	if (event.url.indexOf("/deleteMyAccount") !== -1) {
		forgetUser();
		inAppBrowserRef.show();
	} else {
		inAppBrowserHistory.push(event.url);
	}
}

function forgetUser() {
	localStorage.removeItem("hasLoggedInUsername");

	if (facebookAccessToken()) {
		logoutFacebook();
	}

	if (CONFIG_HASBEARD) {
		$('#beard_choice').show();
	}

	if (CONFIG_HASTATTOOS) {
		$('#tattoos_choice').show();
	}

	$('#sign_up_wait').hide();
	$('#sign_up_choice').show();
	$(window).resize();
}

function IAB_loadstop(event) {

	if (event.url.indexOf(CONFIG_DOMAIN) === -1) {
		return;
	}

	if ((event.url.indexOf("/home") !== -1) && (!localStorage.getItem("hasLoggedInUsername"))) {
		localStorage.setItem("hasLoggedInUsername", true);
	}

	var data = {
		appVersionCode: APP_VERSION_CODE,
		gcmRegistrationId: gcmRegistrationId,
		device: {
			cordova: device.cordova,
			platform: device.platform,
			uuid: device.uuid,
			version: device.version,
			model: device.model
		},
		knownPosition: knownPosition
	};

	inAppBrowserRef.show();

	var details = {
		code: "try { $(document).triggerHandler('appVersionUpdate', [" + APP_VERSION_CODE + ", '" + JSON.stringify(data) + "']);} catch (e) {}"
	};
	inAppBrowserRef.executeScript(details, function() {});

	setTimeout(function() {
		$.mobile.changePage("#page1");
	}, 300);
}

function IAB_loaderror(params) {

	if (params.code = -999) {
		return;
	}

	$.mobile.changePage("#page1");

	alert(CONFIG_STRING_IABERROR + ' (' + params.message + ')');

	inAppBrowserRef.close();
}

function showLoading() {
	$("#loading_huh").hide();
	animateLoading();
	$.mobile.changePage("#loading");

	setTimeout(function() {
		$("#loading_huh").show();
	}, 15000);
}

function animateLoading() {

	var frameTime = 600;

	var frames = [".", "..", "...", "..."];
	var frameNumber = Math.round((new Date().getTime() / frameTime) % frames.length);

	$("#loadingString").html(frames[frameNumber]);

	setTimeout(animateLoading, 100);
}

function cancelLoading() {
	openInAppBrowser(currentlyLoadingUrl);
}