var cameraOptionsPhoto, cameraOptionsLibrary;
var ft;

// signing up stuff
var avatarLocalUri = false;

// send avatarLocalUri up to the server
var uri = encodeURI("https://upload.m14.industries/imageUpload");

function camera_init() {

	cameraOptionsPhoto = {
		sourceType: Camera.PictureSourceType.CAMERA,
		quality: 75,
		targetWidth: 500,
		targetHeight: 500,
		encodingType: Camera.EncodingType.JPEG,
		destinationType: Camera.DestinationType.FILE_URI
	};

	cameraOptionsLibrary = {
		sourceType: Camera.PictureSourceType.SAVEDPHOTOALBUM
	};

	ft = new FileTransfer();

}

$(document).on("click", '#getProfilePhoto', function() {
	navigator.camera.getPicture(onCameraSuccess, onCameraFail, cameraOptionsPhoto);
});

$(document).on("click", '#getProfilePicFromLib', function() {
	navigator.camera.getPicture(onCameraSuccess, onCameraFail, cameraOptionsLibrary);
});

$(document).on("click", '#getNewPhoto', function() {
	navigator.camera.getPicture(onCameraSuccessNewPhoto, onCameraFail, cameraOptionsPhoto);
});

$(document).on("click", '#getNewPicFromLib', function() {
	navigator.camera.getPicture(onCameraSuccessNewPhoto, onCameraFail, cameraOptionsLibrary);
});

function onCameraSuccess(imageURI) {

	avatarLocalUri = imageURI;

	$(".hideOnSavePic").show();
	$(".showOnSavePic").hide();
	$(".uploadProgress").hide();
    $(window).resize();
	
	var options = new FileUploadOptions();
	options.fileKey = "files";
	options.fileName = avatarLocalUri.substr(avatarLocalUri.lastIndexOf('/') + 1);
	options.mimeType = "image/jpeg";
	options.params = {"redirectDomain": CONFIG_DOMAIN};

	ft.onprogress = function(progressEvent) {
		$(".uploadProgress").show();
	    if (progressEvent.lengthComputable) {
	      $(".uploadProgress").html(CONFIG_STRING_UPLOADING + " " + Math.round(100 * progressEvent.loaded / progressEvent.total) + "%");
	    } else {
	      $(".uploadProgress").html(CONFIG_STRING_UPLOADING);
	    }
	};

	ft.upload(avatarLocalUri, uri, function(response) {

		if (response.response.indexOf("Error") === 0) {
			// an error occured
			$(".showOnSavePic").html(response.response + "<br />" + CONFIG_STRING_UPLOADERROR);

		} else {
			// all good, let's go to the signup form!
			$(".showOnSavePic").html("Saved!");

			var signupUrl = "https://"  + CONFIG_DOMAIN + "/signupRedirect?image=" + encodeURI(response.response);

			localStorage.setItem("hasLoggedInUsername", true);
			openInAppBrowser(signupUrl);
		}

	}, function(error) {
		//alert("onCameraSuccess: " + JSON.stringify(error));
		$(".showOnSavePic").html(CONFIG_STRING_UPLOADERROR);
	}, options, true);
}

function onCameraSuccessNewPhoto(imageURI) {

	avatarLocalUri = imageURI;

	$(".hideOnSavePic").show();
	$(".showOnSavePic").hide();
	$("#showOnPicError").hide();
	$(".uploadProgressNewPhoto").hide();
    $(window).resize();

	var options = new FileUploadOptions();
	options.fileKey = "files";
	options.fileName = avatarLocalUri.substr(avatarLocalUri.lastIndexOf('/') + 1);
	options.mimeType = "image/jpeg";
	options.params = {"redirectDomain": CONFIG_DOMAIN};

	ft.onprogress = function(progressEvent) {
		$(".uploadProgressNewPhoto").show();
	    if (progressEvent.lengthComputable) {
	      $(".uploadProgressNewPhoto").html(CONFIG_STRING_UPLOADING + " " + Math.round(100 * progressEvent.loaded / progressEvent.total) + "%");
	    } else {
	      $(".uploadProgressNewPhoto").html(CONFIG_STRING_UPLOADING);
	    }
	};

	ft.upload(avatarLocalUri, uri, function(response) {

		if (response.response.indexOf("Error") === 0) {
			// an error occured
			alert(CONFIG_STRING_UPLOADERROR);

		} else {

			var signupUrl = "https://" + CONFIG_DOMAIN + "/editPics/redirect?image=" + encodeURI(response.response);
			openInAppBrowser(signupUrl)
		}

	}, function(error) {
		alert("onCameraSuccessNewPhoto: " + JSON.stringify(error));
	}, options, true);

}

function onCameraFail(message) {
	if ((message == "Selection cancelled." ) || (message == "Camera cancelled.")) {
		return;
	}
	// Usually this is called if the camera operation is cancelled
	alert(message);
}