// Push notifications
var push, gcmRegistrationId;

function push_init(done) {

	push = PushNotification.init({ 
		android: {
			senderID: "221517825273", 
			iconColor: CONFIG_ICON_COLOR
		}
	});

	push.on('registration', function(data) {
		//alert("registered");
		gcmRegistrationId = data.registrationId;
		done();
	});

	push.on('notification', function(data) {
		// don't force a redirect unless the notification arrived in the background

		if (data.additionalData.foreground) {

			if (inAppBrowserRef) {	
				var details = {
					code: "try { $(document).triggerHandler('appPushNotification', [" + APP_VERSION_CODE + ", '" + JSON.stringify(data) + "']);} catch (e) {}"
				};

				inAppBrowserRef.executeScript(details, function() {});
			}

		} else  {

			var pageToOpen;

			// handle both Android and iOS
			if(data.additionalData.data && data.additionalData.data.url) {
				pageToOpen = data.additionalData.data.url;
			} else if(data.additionalData["gcm.notification.data"] && data.additionalData["gcm.notification.data"].url) {
				pageToOpen = data.additionalData["gcm.notification.data"].url;
			} else if(data.additionalData.url) {
				pageToOpen = data.additionalData.url;
			}

			if (pageToOpen) {
				openInAppBrowser("https://" + CONFIG_DOMAIN + pageToOpen);
			}
		}

	});

	push.on('error', function(e) {
		//alert("oh no " + e.message);
		done();
	});
}
