APP_VERSION_CODE = "11001";

$.getScript("js/lib/facebook.js");
$.getScript("js/lib/geolocation.js");
$.getScript("js/lib/inappbrowser.js");
$.getScript("js/lib/photos.js");
$.getScript("js/lib/push.js");

if (typeof $.mobile === "undefined") {
	$.mobile = {
		changePage: function(pageName) {
			pageName = pageName.replace("#", "");
			$(".page").addClass("hidden");
			$(".page-" + pageName).removeClass("hidden").fadeIn();
		}
	};
}

document.addEventListener("deviceready", onDeviceReady, false);

function onDeviceReady() {
	$(document).ready(function() {

		setTimeout(function() {

			features_init();

			window.open = cordova.InAppBrowser.open;

			push_init(function(){	
				geolocation_init();
				camera_init();

				document.addEventListener("offline", networkCallbackFunctionOffline, false);
				document.addEventListener("online", networkCallbackFunctionOnline, false);

				if (facebookAccessToken()) {
					reLogInWithFacebookAccessToken();
				} else if (isLoggedIn()) {
					$.mobile.changePage("#logginIn");
					openInAppBrowser("https://" + CONFIG_DOMAIN);
				} else {
					$.mobile.changePage("#page1");
				}
			});
		}, 5);
	});
}

var appIsOnline = true;
function networkCallbackFunctionOffline() {
	appIsOnline = false;
}

function networkCallbackFunctionOnline() {
	appIsOnline = true;
}

$(document).on("click", '#offlineTryAgainButton', function() {
	openInAppBrowser("https://" + CONFIG_DOMAIN);
});

function isLoggedIn() {
	return localStorage.getItem("hasLoggedInUsername");
}

$(document).on("click", '.page1_yes', function() {
	showLoginChoice(true);
});

$(document).on("click", '.page1_no', function() {
	showLoginChoice(false);
});

$(document).on("click", '#cancelLogin', function() {
	$.mobile.changePage("#page1");
});

$(document).on("click", '#cancelNewPhoto', function() {
	openInAppBrowser("https://" + CONFIG_DOMAIN + "/editPics/");
});

$(document).on("click", '#cancelLoading', function() {
	cancelLoading();
});

$(document).on("click", '#email_sign_up', emailSignup);
$(document).on("click", '#terms_of_service', openTerms);

$(document).on("click", '#page1_login', function() {
	openInAppBrowser("https://" + CONFIG_DOMAIN);
});


var globalUserChoice;

function showLoginChoice(userChoice) {

	globalUserChoice = userChoice;

	$('#beard_choice').hide();
	$('#tattoos_choice').hide();
	$('#sign_up_choice').show();

	$(window).resize();
}

function openTerms() {
	var options = {
		forceExternal: true
	};

	openInAppBrowser(CONFIG_TERMS, options)
}

function emailSignup() {

	var signupUrl = "https://" + CONFIG_DOMAIN + "/signup"

	if (CONFIG_HASBEARD) {
		signupUrl = "https://" + CONFIG_DOMAIN + "/signup?hasBeard=" + (globalUserChoice ? 'yes' : 'no');
	}

	if (CONFIG_HASTATTOOS) {
		signupUrl = "https://" + CONFIG_DOMAIN + "/signup?hasTattoos=" + (globalUserChoice ? 'yes' : 'no');
	}

	openInAppBrowser(signupUrl);
}

function features_init() {
	if (CONFIG_HASTATTOOS) {
		$("#sign_up_choice").hide();
		$("#tattoos_choice").show();
		$(window).resize();
	}
	if (CONFIG_HASBEARD) {
		$("#sign_up_choice").hide();
		$("#beard_choice").show();
		$(window).resize();
	}
}